const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const publishers = sequelize.define(
    'publishers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

country: {
        type: DataTypes.TEXT,
      
      

      },

website_url: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  publishers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity








    db.publishers.hasMany(db.books, {
      as: 'books_publisher',
      foreignKey: {
          name: 'publisherId',
      },
      constraints: false,
    });
































//end loop






    db.publishers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.publishers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return publishers;
};


